﻿using LibXom.Data;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace LibW4M.Data
{
    public abstract class SaveDataEntry
    {
        internal Guid guid = Guid.NewGuid();
        internal W4SaveFile fileBelongs;
        internal XomContainer mainContainer;
        internal int containerId
        {
            get
            {
                return mainContainer.Id;
            }
        }
        internal string uuid
        {
            get
            {
                return guid.ToString();
            }
        }
        public virtual string FriendlyName 
        {   get 
            {
                return mainContainer.Type.Name;
            }
        }
        public abstract void Load();
        public abstract void Save();
        internal virtual void delete()
        {
            this.mainContainer.Delete();
        }
        public SaveDataEntry (W4SaveFile fileBelongs, XomContainer mainContainer)
        {
            this.fileBelongs = fileBelongs;
            this.mainContainer = mainContainer;

            this.Load();
        }
    }
}
