﻿using LibW4M.Data.InputMapping;
using LibW4M.Data.Teams;
using LibW4M.Data.WeaponFactory;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using W4Gui.Dialogs;

namespace W4Gui.Components
{
    public partial class InputEventMappingPanel : UserControl
    {
        public InputEventMappingPanel()
        {
            InitializeComponent();
        }


        public void SaveInputEventMappingsData(ref InputEventMappingData inputEventMapping)
        {
            // Save general
            inputEventMapping.Message = DataManager.SaveFile.LookupString(this.selMessage.Text);
            inputEventMapping.FEResourceID = DataManager.SaveFile.LookupString(this.selResourceId.Text);
            inputEventMapping.AllowedDuplacates = this.selAllowedDuplicates.Value;
            inputEventMapping.Group = this.selGroup.Value;

            // Save InputMappings
            this.selInputMappings.SaveData();
            inputEventMapping.InputMappings = this.selInputMappings.MappingDataArray;
        }

        public void LoadInputEventMappingsData(InputEventMappingData inputEventMapping)
        {
            // Load general
            this.selMessage.Text = inputEventMapping.Message.Value;
            this.selResourceId.Text = inputEventMapping.FEResourceID.Value;
            this.selAllowedDuplicates.Value = inputEventMapping.AllowedDuplacates;
            this.selGroup.Value = inputEventMapping.Group;

            // Load InputMappings
            this.selInputMappings.LoadData(ref inputEventMapping.InputMappings);

        }

    }
}
